uniform sampler2D texture0_2D;

uniform vec4 Contrast;

uniform vec4 Brightness;

 

vec4 saturate(vec4 inp)

{

  return clamp(inp, 0.0, 1.0);

}

 

void main(void)

{

  Contrast = 0.1;
  Brightness = 0.1;

  //Initialisierungen

  vec4 outp = vec4(0.0, 0.0, 0.0, 0.0);

 

  // Texturen auslesen

  outp = texture2D(texture0_2D, gl_TexCoord[0].xy );

 

  //Kontrast

  vec4 c = vec4(2.0,2.0,2.0,1.0) * (vec4(1.0,1.0,1.0,1.0) - Contrast);

  outp = saturate((outp - vec4(0.5,0.5,0.5,0.5)) * c + vec4(0.5,0.5,0.5,0.5));

 

  //Farben pushen

  outp *= Brightness;

 

  //Helligkeit

  vec4 b = (vec4(1.0,1.0,1.0,1.0) - Contrast * vec4(2.0,2.0,2.0,1.0));

  outp = saturate(outp + b);

 

  gl_FragColor =  outp;

 }